// kicklightmail.cpp : Defines the entry point for the application.
//

#include "stdafx.h"

/* Defines */
#define LIGHTMAIL_APPLICATION_PATH			_T("\\Windows\\lightmail.exe")
#define LIGHTMAIL_APPLICATION_OPT			_T("-n %s")
#define LIGHTMAIL_REG_KEY_NAME				_T("Software\\Sharp\\PhoneApp")
#define LIGHTMAIL_REG_VALUE_NAME			_T("LightMail")
#define LIGHTMAIL_WINDOW_NAME				_T("Cg[ ")

#define LIGHTMAIL_CREATE_WINDOW_NAME		_T("Cg[쐬")
#define LIGHTMAIL_CREATE_WINDOW_CLASS_NAME	_T("Dialog")
#define LIGHTMAIL_CREATE_BODY_NAME			NULL
#define LIGHTMAIL_CREATE_BODY_CLASS_NAME	_T("WCE_EDIT")
#define MAX_SENDNUMBER_LEN					36

#define WM_WAKEUP_LIGHTMAIL					0x1402
#define WPARAM_WAKEUP_LIGHTMAIL				0x1402
#define LPARAM_WAKEUP_LIGHTMAIL				0

/* Typedefs */
typedef struct {
	DWORD	dwArgNum;
	TCHAR	szSendNumber[MAX_SENDNUMBER_LEN];
	TCHAR	szSendFileName[MAX_PATH + 1];
} PROGRAM_OPTIONS;


static
BOOL
ParseParam(
	LPTSTR lpCmdLine,
	PROGRAM_OPTIONS* pOptions
)
{
	BOOL	bRet;
	LPTSTR	pParam = NULL;
	DWORD	dwArgs = 0;

	bRet = FALSE;

	memset(pOptions, 0, sizeof(PROGRAM_OPTIONS));

	if (lpCmdLine != NULL) {
		pParam = wcstok(lpCmdLine, _T(" "));
		while (pParam != NULL) {
			if (dwArgs == 0) {
				wcscpy(pOptions->szSendNumber, pParam);
			}
			else if (dwArgs == 1) {
				wcscpy(pOptions->szSendFileName, pParam);
				
			}
			dwArgs++;
			pParam = wcstok(NULL, _T(" "));
		}
	}

	if (dwArgs == 1 || dwArgs == 2) {
		pOptions->dwArgNum = dwArgs;
		bRet = TRUE;
	}

	return bRet;

}

static
void
InvokeLightMail(
	LPTSTR	pszSendNumber
)
{
	HWND	hWnd = NULL;

	if (pszSendNumber == NULL) {
		return;
	}

	hWnd = FindWindow(NULL, LIGHTMAIL_WINDOW_NAME);

	if (hWnd != NULL) {
		LONG	lResult;
		HKEY	hKey;

		lResult = RegOpenKeyEx(HKEY_CURRENT_USER, LIGHTMAIL_REG_KEY_NAME, 0, 0, &hKey);
		if (lResult == ERROR_SUCCESS) {
			DWORD	dwType;
			DWORD	dwSize;

			dwSize = (_tcslen(pszSendNumber)+1)*sizeof(TCHAR);
			dwType = REG_SZ;

			lResult = RegSetValueEx(hKey, LIGHTMAIL_REG_VALUE_NAME, NULL, dwType, (LPBYTE)pszSendNumber, dwSize);

			if (lResult == ERROR_SUCCESS) {
				PostMessage(hWnd, WM_WAKEUP_LIGHTMAIL, WPARAM_WAKEUP_LIGHTMAIL, LPARAM_WAKEUP_LIGHTMAIL);
			}

			RegCloseKey(hKey);
			hKey = NULL;
		}
	}
	else {
		BOOL	bRet;
		TCHAR	szApplicationPath[MAX_PATH+1];
		TCHAR	szApplicationArgs[MAX_PATH+1];
		PROCESS_INFORMATION pi;

		_tcscpy(szApplicationPath, LIGHTMAIL_APPLICATION_PATH);
		wsprintf(szApplicationArgs, LIGHTMAIL_APPLICATION_OPT, pszSendNumber);

		memset(&pi, 0, sizeof(pi));

		bRet = ::CreateProcess(
						szApplicationPath,
						szApplicationArgs,
						NULL,
						NULL,
						NULL,
						NULL,
						0,
						NULL,
						NULL,
						&pi);
		if (bRet) {
			CloseHandle(pi.hThread);
			CloseHandle(pi.hProcess);
		}
	}
}

HLOCAL
LoadSendDataFromFile(
	LPTSTR	szFileName
)
{
	BOOL	bRet;
	HLOCAL	hRetMem;
	TCHAR	szPath[MAX_PATH + 1];
	HANDLE	hFile = INVALID_HANDLE_VALUE;

	hRetMem = NULL;

	if (szFileName == NULL) {
		return NULL;
	}

	if (szFileName[0] == TEXT('\\')) {
		_tcscpy(szPath, szFileName);
	}
	else {
		LPTSTR	p = NULL;
		GetModuleFileName(NULL, szPath, sizeof(szPath)/sizeof(szPath[0]));
		p = _tcsrchr(szPath, _T('\\'));
		if (p != NULL) {
			*(p+1) = _T('\0');
			_tcscat(szPath, szFileName);
		}
		else {
			_tcscpy(szPath, szFileName);
		}
	}

	hFile = CreateFile(szPath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	if (hFile != INVALID_HANDLE_VALUE) {
		DWORD	dwFileSize	= 0;
		DWORD	dwReaded	= 0;
		LPSTR	pAnsiBuf	= NULL;

		dwFileSize = GetFileSize(hFile, NULL);

		pAnsiBuf = (LPSTR)malloc(dwFileSize + 1);
		if (pAnsiBuf != NULL) {
			memset(pAnsiBuf, 0, dwFileSize + 1);

			bRet = ReadFile(hFile, pAnsiBuf, dwFileSize, &dwReaded, NULL);
			if (bRet) {
				int	nUniCharNum;
				
				nUniCharNum = MultiByteToWideChar(CP_ACP, 0, pAnsiBuf, -1, NULL, 0);
				if (nUniCharNum != 0) {
					HLOCAL	hMem		= NULL;
					int		nUniBufSize	= 0;

					nUniBufSize = nUniCharNum*sizeof(WCHAR);

					hMem = LocalAlloc(0, nUniBufSize);
					if (hMem != NULL) {
						LPWSTR	pUnicodeBuf = NULL;

						pUnicodeBuf = (LPWSTR)LocalLock(hMem);
						if (pUnicodeBuf != NULL) {

							memset(pUnicodeBuf, 0, nUniBufSize);
							MultiByteToWideChar(CP_ACP, 0, pAnsiBuf, -1, pUnicodeBuf, nUniBufSize);
							LocalUnlock(hMem);

							hRetMem = hMem;
						}
						else {
							LocalFree(hMem);
							hMem = NULL;
						}
					}
				}
			}

			free(pAnsiBuf);
			pAnsiBuf = NULL;
		}

		CloseHandle(hFile);
		hFile = NULL;
	}

	return hRetMem;
}

static
HWND
FindBodyWindow(
	HWND	hWndLightMail
)
{
	HWND	hWnd;
	HWND	hWndBody;
	TCHAR	szText[256];

	hWndBody = NULL;	// default return value;

	hWnd = GetWindow(hWndLightMail, GW_CHILD);
	while (hWnd != NULL) {

		if (GetClassName(hWnd, szText, sizeof(szText)/sizeof(szText[0])) &&
				_tcscmp(szText, LIGHTMAIL_CREATE_BODY_CLASS_NAME) == 0) {

			hWndBody = hWnd;
			break;
		}

		hWnd = GetWindow(hWnd, GW_HWNDNEXT);
	}
	
	return hWndBody;
}

static
void
SetTemplate(
	HLOCAL	hNewData,
	BOOL*	pbCanFree
)
{
	int		i;
	HWND	hWndLightMail = NULL;
	HWND	hWndBody = NULL;
	HWND	hWnd = NULL;

	if (hNewData == NULL || pbCanFree == NULL) {
		return;
	}

	*pbCanFree = TRUE;

	//Cg[쐬ʂT(ő5b)
	for (i = 0; i < 5*5; i++) {
		hWndLightMail = FindWindow(LIGHTMAIL_CREATE_WINDOW_CLASS_NAME, LIGHTMAIL_CREATE_WINDOW_NAME);
		if (hWndLightMail != NULL) {
			break;
		}
		Sleep(200);
	}

	//Cg[쐬ʂ̖{̃Rg[T(ő5b)
	if (hWndLightMail != NULL) {
		for (i = 0; i < 5*5; i++) {
			hWndBody = FindBodyWindow(hWndLightMail);
			if (hWndBody != NULL) {
				break;
			}
			Sleep(200);
		}
	}

	if (hWndBody != NULL) {
		HLOCAL	hOrigData = NULL;

		// {̃Rg[ւ̃^bvG~[g
		// (y[Xg̕O[AEg&JEgȂ̂邽߂kluge)
		int	x = 1;
		int y = 1;
		LPARAM lParam;

		lParam = (WORD)y << 16 | (WORD)x;

		SendMessage(hWndBody, WM_LBUTTONDOWN, MK_LBUTTON, lParam);
		SendMessage(hWndBody, WM_LBUTTONUP, MK_LBUTTON, lParam);
		//

		if (OpenClipboard(NULL)) {
			HANDLE	hTmp	= NULL;
			LPWSTR	p		= NULL;
			LPWSTR	pOrigStr	= NULL;
			LPWSTR	pNewStr		= NULL;
			BOOL	bSetClipSucc	= FALSE;

			// Nbv{[hɓĂ錳f[^obNAbv
			hTmp = GetClipboardData(CF_UNICODETEXT);
			if (hTmp != NULL) {
				p = (LPWSTR) LocalLock(hTmp);
				if (p != NULL) {
					hOrigData = LocalAlloc(0, (wcslen(p)+1)*sizeof(WCHAR));
					if (hOrigData != NULL) {
						pOrigStr = (LPWSTR) LocalLock(hOrigData);
						if (pOrigStr != NULL) {
							wcscpy(pOrigStr, p);
							LocalUnlock(pOrigStr);
							pOrigStr = NULL;
						}
						else {
							LocalFree(hOrigData);
							hOrigData = NULL;
						}
					}

					LocalUnlock(hTmp);
					p = NULL;
				}
			}
			//

			// Nbv{[hɃf[^Zbg
			EmptyClipboard();
			if (SetClipboardData(CF_UNICODETEXT, hNewData) != NULL) {

				bSetClipSucc = TRUE;
				*pbCanFree = FALSE;
			}
			CloseClipboard();

			// Nbv{[h̓eCg[AvɃZbg
			if (bSetClipSucc) {
				SendMessage(hWndBody, WM_PASTE, 0, 0);
			}
		}


		if (hOrigData != NULL) {
			// obNAbvf[^ꍇ͌ɖ߂
			if (OpenClipboard(NULL)) {
				EmptyClipboard();
				SetClipboardData(CF_UNICODETEXT, hOrigData);

				CloseClipboard();
			}
			else {
				LocalFree(hOrigData);
				hOrigData = NULL;
			}
		}
	}
}

int
WINAPI
WinMain(
	HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPTSTR    lpCmdLine,
	int       nCmdShow
)
{
  	BOOL				bRet = FALSE;
	PROGRAM_OPTIONS		programOptions;

	bRet = ParseParam(lpCmdLine, &programOptions);

	if (bRet) {
		InvokeLightMail(programOptions.szSendNumber);

		if (programOptions.dwArgNum == 2) {
			HLOCAL	hTmpl = NULL;

			hTmpl = LoadSendDataFromFile(programOptions.szSendFileName);
			if (hTmpl != NULL) {
				BOOL	bCanFree = TRUE;

				SetTemplate(hTmpl, &bCanFree);

				if (bCanFree) {
					LocalFree(hTmpl);
					hTmpl = NULL;
				}

			}
		}
	}
	return 0;
}

